Bug 197172 - nic_get_links() doesn't correctly handle multipart netlink replies (xenguest-install failure)
nic_get_links() doesn't correctly handle multipart netlink replies (xenguest-...
Product: Fedora
Classification: Fedora
Component: libdhcp (Show other bugs)
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jason Vas Dias
: 196739 (view as bug list)
Depends On:
  Show dependency treegraph
Reported: 2006-06-28 21:47 EDT by Mark McLoughlin
Modified: 2007-11-30 17:11 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2006-07-11 16:26:53 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
libdhcp-1.5-multipart-nlmsgs.patch (1.20 KB, patch)
2006-06-28 21:47 EDT, Mark McLoughlin
no flags Details | Diff

  None (edit)
Description Mark McLoughlin 2006-06-28 21:47:56 EDT
Problem occurs using xenguest-install.py on x86_64.

Basically, DHCP fails in anaconda/loader2 because libdhcp claims not to know
anything about eth0.

The error messages are:

         INFO    : sending dhcp request through device eth0
         DEBUG   : waiting for link eth0...
         DEBUG   :    5 seconds.
         WARNING :     no network link detected on eth0
         ERROR   : nic_by_name: no interface named eth0 found
         CRITICAL: dhcp_nic: net_get_by_name(eth0) failed
         DEBUG   : dhcp: DHCP configuration failed

The problem is that nic_get_links() doesn't find eth0 in the first bunch of
nlmsgs returned from nl_recv() ... we need to keep reading messages until we get

It seems to crop up here only because eth0 is initialized after lo, vif0.[0-7],
veth[0-7], sit0 etc.

Attaching a rough patch that fixes it for me
Comment 1 Mark McLoughlin 2006-06-28 21:47:56 EDT
Created attachment 131707 [details]
Comment 2 Heath Petty 2006-07-06 14:54:37 EDT
This problem also affects i386. Applying this patched fixed the issue for me.
Comment 3 David Cantrell 2006-07-11 16:26:53 EDT
Patch applied to CVS, will be in libdhcp-1.7.  Thanks.
Comment 4 Jeremy Katz 2006-07-20 17:57:50 EDT
*** Bug 196739 has been marked as a duplicate of this bug. ***

Note You need to log in before you can comment on or make changes to this bug.